
# function subroutine to define various visualization methods#
import numpy as np


#plotting a binary image of all the detections
def scatter_plot(image_shape, mol_x, mol_y, mag=10):
    # activating the pixels where the index corresponding to the localizations

    #mag = 10
    im = np.zeros([int(image_shape[0]*mag), int(image_shape[1]*mag)])
    for i, j in zip(mol_x, mol_y):
        im[int(j*mag), int(i*mag)] = 1
    return im

#plotting a 2D of all the detections, binning all detections acccurate upo one decial point (or based on the value of the parameter mag) in pne pixel
def histogram(image_shape, mol_x, mol_y, mag=10):
    #mag = 10
    # determining the extents of the histogram image by putting dummy coordinates at the edges
    start = np.array([0])
    end_x = np.array([image_shape[1]])
    end_y = np.array([image_shape[0]])
    mol_x1 = np.hstack((start, mol_x, end_x))
    mol_y1 = np.hstack((start, mol_y, end_y))

    # histogram
    hist, x_edges, y_edges = np.histogram2d(
        mol_y1, mol_x1, bins=[int(image_shape[0]*mag), int(image_shape[1]*mag)])
    extent = [y_edges[0], y_edges[-1], x_edges[0], x_edges[-1]]

    # removing  the values created by the dummy coordnates coordinates
    hist[0, 0] = hist[0, 0]-1
    hist[0, int(image_shape[1]*mag-1)] = hist[0, int(image_shape[1]*mag-1)]-1
    hist[int(image_shape[0]*mag-1), 0] = hist[int(image_shape[0]*mag-1), 0]-1
    hist[int(image_shape[0]*mag-1), int(image_shape[1]*mag-1)
         ] = hist[int(image_shape[0]*mag-1), int(image_shape[1]*mag-1)]-1

    return hist

# plotting 2D averaged shifted histograms by plotting 2D histograms and then shifting them in both x and y direcions and then averaging them 
def average_shifted_histogram(image_shape, mol_x, mol_y, mag=10):

    max_shift_x = 1
    max_shift_y = 1
    num_shifts_x = 2 * max_shift_x + 1
    num_shifts_y = 2 * max_shift_y + 1

    # Shift the histogram in x-direction
    shifted_hists_x = [np.roll(histogram(image_shape, mol_x, mol_y, mag), shift, axis=0)
                       for shift in range(-max_shift_x, max_shift_x+1)]

    # Shift the histogram in y-direction
    shifted_hists_xy = []
    for shift_y in range(-max_shift_y, max_shift_y+1):
        for shifted_hist_x in shifted_hists_x:
            shifted_hist_xy = np.roll(shifted_hist_x, shift_y, axis=1)
            shifted_hists_xy.append(shifted_hist_xy)

    avg_hist = np.sum(shifted_hists_xy, axis=0) / (num_shifts_x * num_shifts_y)

    # Set values below the mean to zero to remove noise
    avg_hist[avg_hist < np.mean(avg_hist)] = 0

    return avg_hist
